﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI

	Private b4xVectEdit_component1, b4xVectEdit_component2, b4xVectEdit_component3 As b4xVectEdit_component
	Private Editor As xScrollView	'XUIScrollView
	Private butRefresh As B4XView
	Dim scale As Double = 1.0
	Dim MinScale As Float = 0.1
	Dim MaxScale As Float = 5
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	Editor.PanelWidth = 1000dip
	Editor.PanelHeight = 1000dip
	
	Generate_Diagram
	
	'SavePicture(File.DirApp, "pic.png", Editor.Panel.Snapshot)
End Sub

Sub Generate_Diagram
	Editor.Panel.RemoveAllViews

	b4xVectEdit_component1.Initialize(Me, "Unit1")
	b4xVectEdit_component1.Name = "Unit1"
	b4xVectEdit_component1.DesignerCreateView(Editor.Panel, Null, Null)
	b4xVectEdit_component1.Base_Resize(Editor.Panel.Width * 0.7, Editor.Height * 0.7)

	b4xVectEdit_component2.Initialize(Me, "Unit2")
	b4xVectEdit_component2.Name = "Unit2"
	b4xVectEdit_component2.DesignerCreateView(Editor.Panel, Null, Null)
	b4xVectEdit_component2.Base_Resize(Editor.Panel.Width * 0.3, Editor.Panel.Height * 0.5)
	
	b4xVectEdit_component3.Initialize(Me, "Unit3")
	b4xVectEdit_component3.InternalView = True
	b4xVectEdit_component3.Name = "Unit3_internal"
	b4xVectEdit_component3.DesignerCreateView(b4xVectEdit_component1.mRect.mBase, Null, Null)
	b4xVectEdit_component3.Base_Resize(200dip, 220dip)
	b4xVectEdit_component3.mRoot.Left = 65dip
	
	#if B4J
		setHandler(Editor.Panel,"setOnScroll", "scroll")
	#End if
End Sub

#if B4J
Sub setHandler(ob As JavaObject, eventName As String, handlerName As String)
	ob.RunMethod(eventName, Array(ob.CreateEventFromUI("javafx.event.EventHandler",handlerName,True)))
End Sub

Sub scroll_Event(MethodName As String, Args() As Object)
	Dim jo As JavaObject
	jo.InitializeStatic("javafx.scene.input.ScrollEvent")
	jo = Args(0)
	If jo.RunMethod("getDeltaY",Null) > 0 And scale <= MaxScale Then
		scale = scale + 0.05
	End If
	If jo.RunMethod("getDeltaY",Null) < 0 And scale >= MinScale Then
		scale = scale - 0.05
	End If
	Scale_Editor(scale)
	
	Editor.PanelWidth = Editor.Width * scale
	Editor.PanelHeight = Editor.Height * scale
End Sub

Sub asJO(o As JavaObject) As JavaObject
	Return o
End Sub
#End if

Sub SavePicture (dir As String, fn As String, bmp As B4XBitmap)
	Dim outs As OutputStream
	outs = File.OpenOutput(dir, fn, False)
	bmp.WriteToStream(outs, 80, "PNG")
	outs.Close
End Sub

Private Sub butRefresh_Click
'	#if B4J
'	SavePicture(File.DirApp, "pic.png", Editor.Panel.Snapshot)
'	#End if
	
	Editor.PanelWidth = 1000dip
	Editor.PanelHeight = 1000dip
	Editor.PositionX = 0
	Editor.PositionY = 0
	Scale_Editor(1)
	
	Generate_Diagram
End Sub

Sub Scale_Editor(factor As Double)
	#if B4J
	asJO(Editor.Panel).RunMethod("setScaleX", Array(factor))
	asJO(Editor.Panel).RunMethod("setScaleY", Array(factor))
	asJO(Editor.Panel).RunMethod("requestLayout", Null)
	#End if	
End Sub